/*
 * Created by SharpDevelop.
 * User: ata
 * Date: 02.07.2006
 * Time: 03:00
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.IO;

namespace caesar
{
	class MainClass
	{
		 static int[] s_ascii	=	{97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122};
		 static int[] b_ascii	=	{65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90};
		
		public static void Main(string[] args)
		{
			caesar_crypt("plain_text.txt","encoded_text.txt",3);
			caesar_decrypt("encoded_text.txt","new_plain_text.txt",3);			
			
		}
		public static void caesar_crypt(string source,string target,int k) {
			
			string S;
			string[]tmp;
			int i,s=-1,ln_count=line_count(source);
			
			StreamReader SR;
			
    		SR=File.OpenText(source);
    		tmp = new string[ln_count];
   			S=SR.ReadLine();
   			
   			 while(S!=null){
   				s++;
   				for(i=0;i<S.Length;i++) {
   					
   					tmp[s]+= Convert.ToString(caesar_char_crypt(S[i],k));
   				}
   				
    			S=SR.ReadLine();
    			
    		}
    		
   			 SR.Close();
   			  StreamWriter SW;
    		  SW=File.CreateText(target);
    		  for(i=0;i<ln_count;i++) {
    		  	SW.WriteLine(tmp[i]);
    		  }
    		  
    		  SW.Close();
   			  
		}
			public static void caesar_decrypt(string source,string target,int k) {
			
			string S;
			string[]tmp;
			int i,s=-1,ln_count=line_count(source);
			
			StreamReader SR;
			SR=File.OpenText(source);
    		tmp = new string[ln_count];
   			S=SR.ReadLine();
   			
   			 while(S!=null){
   				s++;
   				for(i=0;i<S.Length;i++) {
   					
   					tmp[s]+= Convert.ToString(caesar_char_decrypt(S[i],k));
   				}
   				
    			S=SR.ReadLine();
    			
    		}
    		
   			 SR.Close();
   			  StreamWriter SW;
    		  SW=File.CreateText(target);
    		  for(i=0;i<ln_count;i++) {
    		  	SW.WriteLine(tmp[i]);
    		  }
    		  SW.Close();
   			  
		}
		private static char caesar_char_crypt(char chr,int k) {
	
			int i=0;
			
			for(i=0;i<=25;i++) {
				if(s_ascii[i]== (int)chr) {
					return Convert.ToChar(s_ascii[n_mod((k+i),25)]);
				}
				if(b_ascii[i]== (int)chr) {
					return Convert.ToChar(b_ascii[n_mod((k+i),25)]);
				}
			}
		
			return chr;
			
		}
		private static char caesar_char_decrypt(char chr,int k) {
	
			int i=0;
			
			for(i=0;i<=25;i++) {
				if(s_ascii[i]== (int)chr) {
					return Convert.ToChar(s_ascii[n_mod((i-k),25)]);
				}
				if(b_ascii[i]== (int)chr) {
					return Convert.ToChar(b_ascii[n_mod((i-k),25)]);
				}
			}
		
			return chr;
			
		}
		private static int line_count(string source) {
			
			int s=0;
			string S;
			
			StreamReader SR;
			
    		SR=File.OpenText(source);
    		
   			S=SR.ReadLine();
   			
   			 while(S!=null){
   				s++;
   				S=SR.ReadLine();    			
    		}
			return s;
		}
		private static int n_mod(int p1,int p2) { 
			
			int tmp=p1%p2;
			
			if(tmp <0) {
				return p2 + tmp;
			} else {
				return tmp;
			}
		}
	}
}
